import React__default from 'react';
import PropTypes from 'prop-types';
import { styled } from 'styled-components';
import { spacing07, spacing05 } from '@carbon/layout';

var StyledDiv = styled.div.withConfig({
  displayName: "PageWorkArea__StyledDiv",
  componentId: "sc-wobn0e-0"
})(["width:100%;padding:", " ", ";"], spacing07, spacing05);
var propTypes = {
  isOpen: PropTypes.bool,
  children: PropTypes.node.isRequired,
  testId: PropTypes.string
};
var defaultProps = {
  isOpen: false,
  testId: 'page-work-area'
};

/** work area with transitions */
var PageWorkArea = function PageWorkArea(_ref) {
  var isOpen = _ref.isOpen,
    children = _ref.children,
    testId = _ref.testId;
  return isOpen ? /*#__PURE__*/React__default.createElement(StyledDiv, {
    "data-testid": testId
  }, children) : null;
};
PageWorkArea.propTypes = propTypes;
PageWorkArea.defaultProps = defaultProps;
PageWorkArea.__docgenInfo = {
  "description": "work area with transitions",
  "methods": [],
  "displayName": "PageWorkArea",
  "props": {
    "isOpen": {
      "defaultValue": {
        "value": "false",
        "computed": false
      },
      "description": "",
      "type": {
        "name": "bool"
      },
      "required": false
    },
    "testId": {
      "defaultValue": {
        "value": "'page-work-area'",
        "computed": false
      },
      "description": "",
      "type": {
        "name": "string"
      },
      "required": false
    },
    "children": {
      "description": "",
      "type": {
        "name": "node"
      },
      "required": true
    }
  }
};
var PageWorkArea$1 = PageWorkArea;

export { PageWorkArea$1 as default };
