import 'core-js/modules/es.symbol.js';
import 'core-js/modules/es.array.filter.js';
import 'core-js/modules/es.object.get-own-property-descriptor.js';
import 'core-js/modules/es.object.get-own-property-descriptors.js';
import 'core-js/modules/es.object.keys.js';
import 'core-js/modules/es.object.to-string.js';
import 'core-js/modules/web.dom-collections.for-each.js';
import _defineProperty from '@babel/runtime/helpers/defineProperty';
import PropTypes from 'prop-types';
import { IdleLogoutConfirmationModalI18NPropTypes } from './IdleLogoutConfirmationModal/IdleLogoutConfirmationModal.js';

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var SuiteHeaderRoutePropTypes = {
  profile: PropTypes.string,
  navigator: PropTypes.string,
  admin: PropTypes.string,
  logout: PropTypes.string,
  logoutInactivity: PropTypes.string,
  whatsNew: PropTypes.string,
  gettingStarted: PropTypes.string,
  documentation: PropTypes.string,
  requestEnhancement: PropTypes.string,
  support: PropTypes.string,
  about: PropTypes.string,
  // properties rendered as data attributes
  workspaceId: PropTypes.string,
  domain: PropTypes.string
};
var SuiteHeaderApplicationPropTypes = {
  id: PropTypes.string.isRequired,
  name: PropTypes.string.isRequired,
  href: PropTypes.string.isRequired,
  isExternal: PropTypes.bool,
  icon: PropTypes.string
};
var SuiteHeaderWorkspacePropTypes = {
  id: PropTypes.string.isRequired,
  name: PropTypes.string.isRequired,
  href: PropTypes.string.isRequired,
  adminHref: PropTypes.string,
  applications: PropTypes.arrayOf(PropTypes.shape(SuiteHeaderApplicationPropTypes)).isRequired,
  isCurrent: PropTypes.bool
};
var SuiteHeaderSurveyDataPropTypes = {
  surveyLink: PropTypes.string.isRequired,
  privacyLink: PropTypes.string.isRequired
};
var SuiteHeaderI18NPropTypes = _objectSpread({
  help: PropTypes.string,
  profileTitle: PropTypes.string,
  profileManageButton: PropTypes.string,
  profileLogoutButton: PropTypes.string,
  logout: PropTypes.string,
  userIcon: PropTypes.string,
  administrationIcon: PropTypes.string,
  settingsIcon: PropTypes.string,
  profileLogoutModalHeading: PropTypes.string,
  profileLogoutModalSecondaryButton: PropTypes.string,
  profileLogoutModalPrimaryButton: PropTypes.string,
  profileLogoutModalBody: PropTypes.oneOfType([PropTypes.string, PropTypes.func]),
  switcherWorkspace: PropTypes.string,
  switcherWorkspaces: PropTypes.string,
  switcherWorkspaceAdmin: PropTypes.string,
  switcherBackToAppSwitcher: PropTypes.string,
  switcherSelectWorkspace: PropTypes.string,
  switcherAvailableWorkspaces: PropTypes.string,
  switcherSuiteAdmin: PropTypes.string,
  switcherGlobal: PropTypes.string,
  switcherMyApplications: PropTypes.string,
  switcherNavigatorLink: PropTypes.string,
  whatsNew: PropTypes.string,
  documentation: PropTypes.string,
  requestEnhancement: PropTypes.string,
  about: PropTypes.string,
  support: PropTypes.string,
  gettingStarted: PropTypes.string,
  surveyTitle: PropTypes.oneOfType([PropTypes.string, PropTypes.func]),
  surveyText: PropTypes.string,
  surveyPrivacyPolicy: PropTypes.string
}, IdleLogoutConfirmationModalI18NPropTypes);

export { SuiteHeaderApplicationPropTypes, SuiteHeaderI18NPropTypes, SuiteHeaderRoutePropTypes, SuiteHeaderSurveyDataPropTypes, SuiteHeaderWorkspacePropTypes };
