import 'core-js/modules/es.symbol.js';
import 'core-js/modules/es.symbol.description.js';
import React__default from 'react';
import PropTypes from 'prop-types';
import { settings } from '../../constants/Settings.js';

var iotPrefix = settings.iotPrefix;
var propTypes = {
  /** optional icon to visually describe catalog item */
  icon: PropTypes.node,
  title: PropTypes.string.isRequired,
  description: PropTypes.node
};
var defaultProps = {
  icon: null,
  description: null
};
/** Reusable widget to show Catalog contents in a tile catalog */
var CatalogContent = function CatalogContent(_ref) {
  var icon = _ref.icon,
    title = _ref.title,
    description = _ref.description;
  return /*#__PURE__*/React__default.createElement("div", {
    className: "".concat(iotPrefix, "--sample-tile")
  }, icon ? /*#__PURE__*/React__default.createElement("div", {
    className: "".concat(iotPrefix, "--sample-tile-icon")
  }, icon) : null, /*#__PURE__*/React__default.createElement("div", {
    className: "".concat(iotPrefix, "--sample-tile-contents")
  }, /*#__PURE__*/React__default.createElement("div", {
    className: "".concat(iotPrefix, "--sample-tile-title")
  }, /*#__PURE__*/React__default.createElement("span", {
    title: title
  }, title)), /*#__PURE__*/React__default.createElement("div", {
    className: "".concat(iotPrefix, "--sample-tile-description")
  }, description)));
};
CatalogContent.propTypes = propTypes;
CatalogContent.defaultProps = defaultProps;
CatalogContent.__docgenInfo = {
  "description": "Reusable widget to show Catalog contents in a tile catalog",
  "methods": [],
  "displayName": "CatalogContent",
  "props": {
    "icon": {
      "defaultValue": {
        "value": "null",
        "computed": false
      },
      "description": "optional icon to visually describe catalog item",
      "type": {
        "name": "node"
      },
      "required": false
    },
    "description": {
      "defaultValue": {
        "value": "null",
        "computed": false
      },
      "description": "",
      "type": {
        "name": "node"
      },
      "required": false
    },
    "title": {
      "description": "",
      "type": {
        "name": "string"
      },
      "required": true
    }
  }
};
var CatalogContent$1 = CatalogContent;

export { CatalogContent$1 as default };
