import React__default from 'react';
import PropTypes from 'prop-types';
import { Tile } from '@carbon/react';
import classnames from 'classnames';
import { settings } from '../../constants/Settings.js';

var iotPrefix = settings.iotPrefix;
var propTypes = {
  tiles: PropTypes.arrayOf(PropTypes.node),
  testId: PropTypes.string
};
var defaultProps = {
  tiles: null,
  testId: 'tile-group'
};

/** this component just exists to make the last tile look good in a responsive flex container */
var TileGroup = function TileGroup(_ref) {
  var tiles = _ref.tiles,
    className = _ref.className,
    testId = _ref.testId;
  return /*#__PURE__*/React__default.createElement("div", {
    "data-testid": testId,
    className: classnames(className, "".concat(iotPrefix, "--tile-group"))
  }, tiles, /*#__PURE__*/React__default.createElement(Tile, {
    className: "".concat(iotPrefix, "--greedy-tile")
  }));
};
TileGroup.propTypes = propTypes;
TileGroup.defaultProps = defaultProps;
TileGroup.__docgenInfo = {
  "description": "this component just exists to make the last tile look good in a responsive flex container",
  "methods": [],
  "displayName": "TileGroup",
  "props": {
    "tiles": {
      "defaultValue": {
        "value": "null",
        "computed": false
      },
      "description": "",
      "type": {
        "name": "arrayOf",
        "value": {
          "name": "node"
        }
      },
      "required": false
    },
    "testId": {
      "defaultValue": {
        "value": "'tile-group'",
        "computed": false
      },
      "description": "",
      "type": {
        "name": "string"
      },
      "required": false
    }
  }
};
var TileGroup$1 = TileGroup;

export { TileGroup$1 as default };
