import PropTypes from 'prop-types';
import React__default from 'react';
import { BASE_CLASS_NAME } from './valueCardUtils.js';

var propTypes = {
  unit: PropTypes.string,
  testId: PropTypes.string
};
var defaultProps = {
  unit: '',
  testId: 'unit'
};
var BEM_BASE = "".concat(BASE_CLASS_NAME, "__attribute-unit");

/**
 * This components job is determining how to render different kinds of units
 */
var UnitRenderer = function UnitRenderer(_ref) {
  var unit = _ref.unit,
    testId = _ref.testId;
  return /*#__PURE__*/React__default.createElement("span", {
    "data-testid": testId,
    style: {
      '--default-font-size': '1.25rem'
    },
    className: BEM_BASE
  }, unit);
};
UnitRenderer.propTypes = propTypes;
UnitRenderer.defaultProps = defaultProps;
UnitRenderer.__docgenInfo = {
  "description": "This components job is determining how to render different kinds of units",
  "methods": [],
  "displayName": "UnitRenderer",
  "props": {
    "unit": {
      "defaultValue": {
        "value": "''",
        "computed": false
      },
      "description": "",
      "type": {
        "name": "string"
      },
      "required": false
    },
    "testId": {
      "defaultValue": {
        "value": "'unit'",
        "computed": false
      },
      "description": "",
      "type": {
        "name": "string"
      },
      "required": false
    }
  }
};
var UnitRenderer$1 = UnitRenderer;

export { UnitRenderer$1 as default };
