'use strict';

require('core-js/modules/es.symbol.js');
require('core-js/modules/es.array.filter.js');
require('core-js/modules/es.object.get-own-property-descriptor.js');
require('core-js/modules/es.object.get-own-property-descriptors.js');
require('core-js/modules/es.object.keys.js');
require('core-js/modules/es.object.to-string.js');
require('core-js/modules/web.dom-collections.for-each.js');
var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var PropTypes = require('prop-types');
var IdleLogoutConfirmationModal = require('./IdleLogoutConfirmationModal/IdleLogoutConfirmationModal.js');

function _interopDefault (e) { return e && e.__esModule ? e : { default: e }; }

var _defineProperty__default = /*#__PURE__*/_interopDefault(_defineProperty);
var PropTypes__default = /*#__PURE__*/_interopDefault(PropTypes);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default.default(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var SuiteHeaderRoutePropTypes = {
  profile: PropTypes__default.default.string,
  navigator: PropTypes__default.default.string,
  admin: PropTypes__default.default.string,
  logout: PropTypes__default.default.string,
  logoutInactivity: PropTypes__default.default.string,
  whatsNew: PropTypes__default.default.string,
  gettingStarted: PropTypes__default.default.string,
  documentation: PropTypes__default.default.string,
  requestEnhancement: PropTypes__default.default.string,
  support: PropTypes__default.default.string,
  about: PropTypes__default.default.string,
  // properties rendered as data attributes
  workspaceId: PropTypes__default.default.string,
  domain: PropTypes__default.default.string
};
var SuiteHeaderApplicationPropTypes = {
  id: PropTypes__default.default.string.isRequired,
  name: PropTypes__default.default.string.isRequired,
  href: PropTypes__default.default.string.isRequired,
  isExternal: PropTypes__default.default.bool,
  icon: PropTypes__default.default.string
};
var SuiteHeaderWorkspacePropTypes = {
  id: PropTypes__default.default.string.isRequired,
  name: PropTypes__default.default.string.isRequired,
  href: PropTypes__default.default.string.isRequired,
  adminHref: PropTypes__default.default.string,
  applications: PropTypes__default.default.arrayOf(PropTypes__default.default.shape(SuiteHeaderApplicationPropTypes)).isRequired,
  isCurrent: PropTypes__default.default.bool
};
var SuiteHeaderSurveyDataPropTypes = {
  surveyLink: PropTypes__default.default.string.isRequired,
  privacyLink: PropTypes__default.default.string.isRequired
};
var SuiteHeaderI18NPropTypes = _objectSpread({
  help: PropTypes__default.default.string,
  profileTitle: PropTypes__default.default.string,
  profileManageButton: PropTypes__default.default.string,
  profileLogoutButton: PropTypes__default.default.string,
  logout: PropTypes__default.default.string,
  userIcon: PropTypes__default.default.string,
  administrationIcon: PropTypes__default.default.string,
  settingsIcon: PropTypes__default.default.string,
  profileLogoutModalHeading: PropTypes__default.default.string,
  profileLogoutModalSecondaryButton: PropTypes__default.default.string,
  profileLogoutModalPrimaryButton: PropTypes__default.default.string,
  profileLogoutModalBody: PropTypes__default.default.oneOfType([PropTypes__default.default.string, PropTypes__default.default.func]),
  switcherWorkspace: PropTypes__default.default.string,
  switcherWorkspaces: PropTypes__default.default.string,
  switcherWorkspaceAdmin: PropTypes__default.default.string,
  switcherBackToAppSwitcher: PropTypes__default.default.string,
  switcherSelectWorkspace: PropTypes__default.default.string,
  switcherAvailableWorkspaces: PropTypes__default.default.string,
  switcherSuiteAdmin: PropTypes__default.default.string,
  switcherGlobal: PropTypes__default.default.string,
  switcherMyApplications: PropTypes__default.default.string,
  switcherNavigatorLink: PropTypes__default.default.string,
  whatsNew: PropTypes__default.default.string,
  documentation: PropTypes__default.default.string,
  requestEnhancement: PropTypes__default.default.string,
  about: PropTypes__default.default.string,
  support: PropTypes__default.default.string,
  gettingStarted: PropTypes__default.default.string,
  surveyTitle: PropTypes__default.default.oneOfType([PropTypes__default.default.string, PropTypes__default.default.func]),
  surveyText: PropTypes__default.default.string,
  surveyPrivacyPolicy: PropTypes__default.default.string
}, IdleLogoutConfirmationModal.IdleLogoutConfirmationModalI18NPropTypes);

exports.SuiteHeaderApplicationPropTypes = SuiteHeaderApplicationPropTypes;
exports.SuiteHeaderI18NPropTypes = SuiteHeaderI18NPropTypes;
exports.SuiteHeaderRoutePropTypes = SuiteHeaderRoutePropTypes;
exports.SuiteHeaderSurveyDataPropTypes = SuiteHeaderSurveyDataPropTypes;
exports.SuiteHeaderWorkspacePropTypes = SuiteHeaderWorkspacePropTypes;
