'use strict';

var PropTypes = require('prop-types');

function _interopDefault (e) { return e && e.__esModule ? e : { default: e }; }

var PropTypes__default = /*#__PURE__*/_interopDefault(PropTypes);

var ViewsPropType = PropTypes__default.default.arrayOf(PropTypes__default.default.shape({
  /** The ID of the view  */
  id: PropTypes__default.default.string,
  /** True if this view is public, False if private */
  isPublic: PropTypes__default.default.bool,
  /** True if this the user can edit this view  */
  isEditable: PropTypes__default.default.bool,
  /** True if this the user can delete this view  */
  isDeleteable: PropTypes__default.default.bool,
  /** The name of the view */
  title: PropTypes__default.default.string,
  /** A string that describes what this view contains */
  description: PropTypes__default.default.string
}));

exports.ViewsPropType = ViewsPropType;
